<!--
  @File Name          : listeprojet.html
  @Description        : 
  @Author             : ChangeMeIn@UserSettingsUnder.SFDoc
  @Group              : 
  @Last Modified By   : ChangeMeIn@UserSettingsUnder.SFDoc
  @Last Modified On   : 07/06/2020 à 14:12:46
  @Modification Log   : 
  Ver       Date            Author      		    Modification
  1.0    27/05/2020   ChangeMeIn@UserSettingsUnder.SFDoc     Initial Version
-->
<template>
	<div class='slds-card'>
		<!-- titre -->
		<div class="slds-m-bottom_small">
			<p class="slds-text-heading_large slds-text-align_center"><b>List of projects</b>
			</p>
		</div>
		<!-- **************searchProjet******************** -->
		<div class="slds-align_absolute-center">
			<lightning-layout>
				<lightning-layout-item padding="around-small">
					<div class="header-column">
						<p class="field-title" title="project name">Project Name:</p>
					</div>
					<lightning-input label="Name" name="Name" variant="label-hidden" onchange={handleNameserchChange} value={Name}></lightning-input>
				</lightning-layout-item>
				<lightning-layout-item padding="around-small">
					<div class="header-column">
						<p class="field-title" title="State">State</p>
					</div>
					<lightning-combobox label="state" name="state" value={Etat__c} placeholder="Select state" options={options} variant="label-hidden" onchange={handleEtat__cChange}></lightning-combobox>
				</lightning-layout-item>
				<lightning-layout-item padding="around-small">
					<div class="header-column">
						<p class="field-title" title="Category">Category</p>
					</div>
					<lightning-input label="Category" name="Gat_gorie__c" variant="label-hidden" onchange={handleGat_gorie__cChange} value={Gat_gorie__c}></lightning-input>
				</lightning-layout-item>
				<lightning-layout-item padding="around-small">
					<lightning-button-icon style="color: royalblue ;margin-top: 19px;" icon-name="utility:search" alternative-text="Search" variat="brand" class="slds-button slds-button_icon slds-button_icon-border-filled" title="Search" onclick={handleSearch}></lightning-button-icon>
				</lightning-layout-item>
			</lightning-layout>
		</div>
		<!-- bouton ajouter projet -->
		<lightning-button class="btt_ajouter" icon-name="utility:add" label="Ajouter projet" variat="brand" onclick={openmodal1}></lightning-button>
		<!--Tableau de Projet-->
		<div style="width: auto;">
			<!--Tableau de Projet-->
			<template if:true={data}>
				<template if:false={tableDisp}>
					<lightning-datatable data={data} columns={columns} key-field="id" hide-checkbox-column="true" onrowaction={handleRowActions}></lightning-datatable>
				</template>
			</template>
			<!--Tableau de Projet Search-->
			<template if:true={tableDisp}>
        <lightning-datatable data={ProjectLists}
        columns={columnsSearch}
          key-field="id"
          hide-checkbox-column="true"
          onrowaction={handleRowActions}></lightning-datatable>
			</template>
		</div>
		<!-- Spinner -->
		<div if:true={showLoadingSpinner}>
			<lightning-spinner alternative-text="Loading" size="large"></lightning-spinner>
		</div>
		<!-- Detail view modal -->
		<template if:true={bShowModal}>
			<section role="dialog" tabindex="-1" aria-labelledby="modal-heading-03" aria-modal="true" aria-describedby="modal-content-id-3" class="slds-modal slds-fade-in-open">
				<div class="slds-modal__container">
					<!-- modal header -->
					<header class="slds-modal__header">
						<button class="slds-button slds-button_icon slds-modal__close slds-button_icon-inverse" title="Close" onclick={openOrCloseModal}>
							<lightning-icon icon-name="utility:close" alternative-text="close" variant="inverse" size="small"></lightning-icon>
						</button>
						<h2 id="modal-heading-03" class="slds-text-heading_medium slds-hyphenate" if:false={isEditForm}>
            Record Detail
          </h2>
						<h2 id="modal-heading-02" class="slds-text-heading_medium slds-hyphenate" if:true={isEditForm}>
            Update Record Values
          </h2>
					</header>
					<!-- modal body -->
					<div class="slds-modal__content slds-p-around_medium" id="modal-content-id-3" if:false={isEditForm}>
						<dl class="slds-list_horizontal slds-wrap"> <dt class="slds-item_label slds-truncate" title="project name">Project Name:</dt>
							<dd class="slds-item_detail slds-truncate">{record.Name}</dd> <dt class="slds-item_label slds-truncate" title="Category">Category:</dt>
							<dd class="slds-item_detail slds-truncate">{record.Gat_gorie__c}</dd> <dt class="slds-item_label slds-truncate" title="State">State:</dt>
							<dd class="slds-item_detail slds-truncate">{record.Etat__c}</dd> <dt class="slds-item_label slds-truncate" title="Type">Type:</dt>
							<dd class="slds-item_detail slds-truncate">{record.Type__c}</dd> <dt class="slds-item_label slds-truncate" title="Priority">Priority:</dt>
							<dd class="slds-item_detail slds-truncate">{record.Priorit__c}</dd> <dt class="slds-item_label slds-truncate" title="Start date">Start date:</dt>
							<dd class="slds-item_detail slds-truncate">{record.Date_Debut__c}</dd> <dt class="slds-item_label slds-truncate" title="End date">End date:</dt>
							<dd class="slds-item_detail slds-truncate">{record.Date_fin__c}</dd> <dt class="slds-item_label slds-truncate" title="Consumed Time">Consumed Time:</dt>
							<dd class="slds-item_detail slds-truncate">{record.Temps_Consome__c}</dd>
						</dl>
					</div>
					<!-- showing record edit form -->
					<div if:true={isEditForm} class="slds-theme_default">
						<lightning-record-edit-form layout-type="Full" record-id={currentRecordId} object-api-name="Projet__c" onsubmit={handleSubmit} onsuccess={handleSuccess}>
							<lightning-messages></lightning-messages>
							<lightning-output-field field-name="Name"></lightning-output-field>
							<lightning-input-field field-name="Gat_gorie__c"></lightning-input-field>
							<lightning-input-field field-name="Etat__c"></lightning-input-field>
							<lightning-input-field field-name="Type__c"></lightning-input-field>
							<lightning-input-field field-name="Priorit__c"></lightning-input-field>
							<lightning-input-field field-name="Date_Debut__c"></lightning-input-field>
							<lightning-input-field field-name="Date_fin__c"></lightning-input-field>
							<br/>
							<div style="text-align:center;">
								<lightning-button class="slds-m-top_small" variant="brand" type="submit" name="update" label="Update"></lightning-button>
							</div>
						</lightning-record-edit-form>
						<br/>
						<div></div>
					</div>
					<!-- modal footer start-->
					<footer class="slds-modal__footer" if:false={isEditForm}>
						<lightning-button variant="brand" label="Close" title="Close" onclick={closeModal}></lightning-button>
					</footer>
				</div>
			</section>
			<div class="slds-backdrop slds-backdrop_open"></div>
		</template>
	</div>
	<template if:true={openmodel1}>
		<div class="demo-only"></div>
		<section role="dialog" tabindex="-1" aria-labelledby="modal-heading-01" aria-modal="true" aria-describedby="modal-content-id-1" class="slds-modal slds-fade-in-open">
			<div class="slds-modal__container">
				<header class="slds-modal__header">
					<button class="slds-button slds-button_icon slds-modal__close slds-button_icon-inverse" title="Close" onclick={openOrCloseModal}>
						<lightning-icon icon-name="utility:close" size="medium"></lightning-icon> <span class="slds-assistive-text">Close</span>
					</button>
					<h2 id="modal-heading-01" class="slds-text-heading_medium slds-hyphenate">Add Project</h2>
				</header>
				<div class="slds-modal__content slds-p-around_medium" id="modal-content-id-1">
					<table>
						<tr>
							<td>
								<p>project name:</p>
							</td>
							<td>
								<lightning-input type="text" label="" onchange={handleNamechange} required="required" value={ProjetRecord.Name} placeholder="type here..."></lightning-input>
							</td>
						</tr>
						<TR></TR>
						<tr>
							<td>
								<p>project status:</p>
							</td>
							<td>
								<lightning-combobox name="Etat__c" label="State" value={value} placeholder="-Select-" options={pickListvalues} onchange={handleetatchange}></lightning-combobox>
							</td>
						</tr>
						<TR>
							<TD>
								<lightning-input type="hidden" label=" " placeholder="type here..."></lightning-input>
							</TD>
						</TR>
						<TR></TR>
						<tr>
							<td>
								<p>Type:</p>
							</td>
							<td>
								<lightning-combobox name="Type" label=" " value={value} placeholder="-Select-" options={Type__c} onchange={handleTypechange}></lightning-combobox>
							</td>
						</tr>
						<TR>
							<TD>
								<lightning-input type="hidden" label=" " placeholder="type here..."></lightning-input>
							</TD>
						</TR>
						<TR></TR>
						<tr>
							<td>
								<p>Category:</p>
							</td>
							<td>
								<lightning-input type="text" label="" onchange={handlecategoriechange} value={ProjetRecord.Gat_gorie__c} placeholder="type here..."></lightning-input>
							</td>
						</tr>
						<TR>
							<TD>
								<lightning-input type="hidden" label=" " placeholder="type here..."></lightning-input>
							</TD>
						</TR>
						<tr>
							<td>
								<p>Priority:</p>
							</td>
							<td>
								<lightning-combobox name="Priority" label=" " value={value} placeholder="-Select-" options={pickListvaluesByRecordType} onchange={handlePrioritechange}></lightning-combobox>
							</td>
						</tr>
						<TR>
							<TD>
								<lightning-input type="hidden" label=" " placeholder="type here..."></lightning-input>
							</TD>
						</TR>
						<TR></TR>
						<tr>
							<td>
								<p>Start date:</p>
							</td>
							<td>
								<lightning-input type="date" name="input1" label=" " onchange={handleDateDebutchange} value={ProjetRecord.Date_Debut__c}></lightning-input>
							</td>
						</tr>
						<TR>
							<TD>
								<lightning-input type="hidden" label=" " placeholder="type here..."></lightning-input>
							</TD>
						</TR>
						<TR></TR>
						<tr>
							<td>
								<p>End date:</p>
							</td>
							<td>
								<lightning-input type="date" name="input2" label=" " onchange={handleDatefinchange} value={ProjetRecord.Date_fin__c}></lightning-input>
							</td>
						</tr>
						<tr>
							<td>
								<p>Resource:</p>
							</td>
							<td>
										<div class="slds-form-element">
											
											<div class="slds-form-element__control">
												<div class="slds-combobox_container">
													
													<div class={txtclassname} data-id="resultBox" aria-expanded="false" aria-haspopup="listbox" role="combobox">
														<div class="slds-form-element__control slds-input-has-icon slds-input-has-icon slds-input-has-icon_left-right" role="none">
															
															<div>
																<span class="slds-icon_container slds-icon-utility-search slds-input__icon iconheight">
																</span> 
															</div>
															<lightning-input required={required} data-id="userinput" label={Label} name="searchText" onchange={searchField} class="leftspace"></lightning-input>
															<span class="slds-icon_container slds-icon-utility-search slds-input__icon slds-input__icon_right iconheight">
															</span>
														</div>
														<div class="slds-form-element__control slds-input-has-icon slds-input-has-icon slds-input-has-icon_left-right" role="none">
															<template for:each={selectedRecords} for:item="serecord">
																<span key={serecord.recId}>
																<lightning-pill label={serecord.recName} name={serecord.recId} onremove={removeRecord}>
																		<lightning-icon icon-name={iconName} variant="circle" alternative-text={serecord.recName}></lightning-icon>
																	</lightning-pill>
																</span>
															</template>
														</div>
													
														<!-- Second part display result -->
														<div id="listbox-id-1" class="slds-dropdown slds-dropdown_length-with-icon-7 slds-dropdown_fluid" role="listbox">
															<ul class="slds-listbox slds-listbox_vertical" role="presentation">
																<template for:each={searchRecords} for:item="serecord">
																	<li role="presentation" class="slds-listbox__item" key={serecord.recId}>
																		
																		<div data-id={serecord.recId} data-name={serecord.recName} onclick={setSelectedRecord} class="slds-media slds-listbox__option slds-listbox__option_entity slds-listbox__option_has-meta" role="option">
																			<span class="slds-media__figure">
																				<span class="slds-icon_container slds-icon-standard-account">
																				</span>
																			</span>
																			<span class="slds-media__body">
																				<span class="slds-listbox__option-text slds-listbox__option-text_entity">{serecord.recName}</span>
																				<span class="slds-listbox__option-meta slds-listbox__option-meta_entity">{objectName} • {serecord.recName}</span>
																			</span>
																		</div>
																	</li>
																</template>
															</ul>
														</div>
														<div if:true={messageFlag}>
															No result found.
														</div>
														<div if:true={LoadingText}>
															Loading...
														</div>
													</div>
												</div>
											</div>
										</div>
									</div>
							
							</td>
						</tr>
					</table>
				</div>
				<footer class="slds-modal__footer">
					<lightning-button label="Cancel" variant="neutral" onclick={closeModal1}></lightning-button>
					<lightning-button label="Save" variant="brand" onclick={saveMethodProjet}></lightning-button>
				</footer>
			</div>
		</section>
		<div class="slds-backdrop slds-backdrop_open"></div>
		</div>
	</template>
</template>